unit fmWindowClassNameFinder;

{ Example application for DropMaster.

  Demonstrates the use of the TDMTextSource OnGiveFeedback event by displaying
  the Window class name of any window dragged over.

  Last modified:  08/05/2001}

interface

uses
  Windows, Types, Messages, SysUtils,
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DMComps;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    DMTextSource1: TDMTextSource;
    procedure DMTextSource1GiveFeedback(Sender: TObject;
      effect: TDropEffect; var defCursors: Boolean);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DMTextSource1BeforeDrop(Sender: TObject; Donor: TComponent;
      var DropText: string; var CancelDrop: Boolean);
  private
    function GetWindowClassUnderCursor: string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DMTextSource1BeforeDrop(Sender: TObject; Donor: TComponent;
  var DropText: string; var CancelDrop: Boolean);
// Make sure we don't actually drop the text of the panel anywhere
begin
   CancelDrop := true;
end;

procedure TForm1.DMTextSource1GiveFeedback(Sender: TObject;
  effect: TDropEffect; var defCursors: Boolean);
begin
  // Use the "help" cursor
  defCursors := false;
  SetCursor(Screen.Cursors[crHelp]);
  Label2.Caption := GetWindowClassUnderCursor;
end;

function TForm1.GetWindowClassUnderCursor: string;
const
  bufLen = 255;
var
  aPt: TPoint;
  aHWnd: HWnd;
begin
  GetCursorPos(aPt);
  aHWnd := WindowFromPoint(aPt);

  if  aHWnd <> 0 then
  begin
    SetLength(Result, bufLen);
    GetClassName(aHWnd, PChar(Result), bufLen);
    SetLength(Result, StrLen(PChar(Result)));
  end
  else Result := '';

end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if DragDetect(Panel1.Handle, POINT(X,Y)) then
  begin
    DMTextSource1.Execute;
  end;
    
end;

end.
